# Algorithm 仓库

欢迎来到 Algorithm 仓库！这个仓库用于记录和分享使用 JavaScript 实现的各种算法，包括排序算法、工具函数、力扣题解及常用数据结构。所有代码均使用 ESModule 模块化。

## 目录

- [Algorithm 仓库](#algorithm-仓库)
  - [目录](#目录)
  - [介绍](#介绍)
  - [目录结构](#目录结构)
  - [排序算法](#排序算法)
  - [工具函数](#工具函数)
  - [力扣题解](#力扣题解)
    - [简单难度](#简单难度)
    - [中等难度](#中等难度)
    - [困难难度](#困难难度)
  - [链表](#链表)
  - [树](#树)
  - [哈希工具](#哈希工具)
  - [提交前缀](#提交前缀)
  - [许可证](#许可证)

## 介绍

该仓库旨在帮助开发者更好地学习和理解算法。所有算法均使用 JavaScript 实现，并且遵循 ESModule 模块化规范。

## 目录结构

- `sort/`: 排序算法相关目录
- `util/`: 工具函数目录
- `leetcode/`: 力扣题解目录，按难度分类
  - `easy/`: 简单难度题目
  - `medium/`: 中等难度题目
  - `hard/`: 困难难度题目
- `list/`: 链表相关数据结构目录
- `tree/`: 树相关数据结构目录
- `hash/`: 常用哈希工具函数目录
- `c_solutions`: c 语言相关算法实现(详细请看 c_solutions/README.md)
- `go_solutions`: go 语言相关算法实现(详细请看 go_solutions/README.md)

## 排序算法

`sort/` 目录包含各种排序算法的实现。每个算法都附带了详细的注释和示例代码。

## 工具函数

`util/` 目录包含在算法实现中常用的工具函数。这些函数旨在提高代码的可读性和重用性。

## 力扣题解

`leetcode/` 目录按难度分类存放力扣题解。每个题解都包含题目描述、解决方案和代码实现。

### 简单难度

`leetcode/easy/` 目录存放简单难度的力扣题目及其解答。

### 中等难度

`leetcode/medium/` 目录存放中等难度的力扣题目及其解答。

### 困难难度

`leetcode/hard/` 目录存放困难难度的力扣题目及其解答。

## 链表

`list/` 目录包含链表相关的数据结构和算法实现。包括单链表、双链表等常见链表类型。

## 树

`tree/` 目录包含树相关的数据结构和算法实现。包括二叉树、二叉搜索树等常见树结构。

## 哈希工具

`hash/` 目录包含常用的哈希工具函数。这些函数用于实现哈希表等数据结构。

类型表示更改的性质。以下是支持的类型：

## 提交前缀

- `feat`: 新功能
- `fix`: 修复 Bug
- `docs`: 仅文档更改
- `style`: 不影响代码含义的更改（空格、格式、缺少分号等）
- `refactor`: 既不是修复 Bug 也不是添加功能的代码更改
- `perf`: 提高性能的代码更改
- `test`: 添加缺失的测试或纠正现有测试
- `chore`: 构建过程或辅助工具和库（如文档生成）的更改
- `revert`: 恢复先前的提交

## 许可证

本仓库根据 MIT 许可证进行许可。有关更多信息，请参见 [LICENSE](LICENSE) 文件。

---

感谢你对 Algorithm 仓库的贡献！你的努力有助于使其成为算法学习和分享的宝贵资源。
